# ------------------------------------------------------------------------------
# NAME:
#   RBC_Library
# CREATOR:
#   杨晨晨(Sugar) - 932180146@qq.com
# WebSite:
#   bc8 & 杨晨晨(Sugar) - www.rbc321.cn
# DESCRIPTION:
#  This plugin provides extended support for all RBC plugins.
#  All RBC plugins need to install the RBC Library!
#
# NOTE:
#  * The RBC plug-in uses RubyEncoder to protect the product.
#    RubyEncoder does not support Chinese file paths,
#    so try not to use the Chinese username.
#  * only support more than 2014 version!
#  * PC does not support less than 8 IE browsers.
# ------------------------------------------------------------------------------

require 'sketchup'
require 'extensions'

require 'English'

module RBC
  unless file_loaded?( __FILE__ ) || defined?(RBC_EXTENSION)

    # Plugin information
    PLUGINS_PATH  = __FILE__.force_encoding('UTF-8').freeze            # LOADER FILE PATH
    RBC_NAME      = 'RBC_Library'.freeze                                       # Plugin NAME
    RBC_VERSION_  = [2, 8, 0].freeze                                           # VERSION
    RBC_VERSION   = RBC_VERSION_.join('.').freeze                              # VERSION_
    DIR_NAME      = (RBC_NAME + '_v' + RBC_VERSION).freeze                     # MAIN DIRNAME
    RBC_CORE_DIR  = File.join(File.dirname(PLUGINS_PATH), DIR_NAME).freeze     # MAIN DIR
    #
    RBC_EXTENSION = SketchupExtension.new(RBC_NAME, File.join(RBC_CORE_DIR, 'startup'))
    RBC_EXTENSION.version=     RBC_VERSION
    RBC_EXTENSION.creator=     '杨晨晨(Sugar)'
    RBC_EXTENSION.copyright=   'Copyright (c) 2015—2017 杨晨晨(Sugar) All rights reserved.'
    RBC_EXTENSION.description= 'This plugin provides extended support for all RBC plugins. All RBC plugins need to install the RBC extension library! (only support more than 2014 version!)email:932180146@qq.com'
    Sketchup.register_extension(RBC_EXTENSION, (Sketchup.version.to_i >= 14))

    file_loaded(__FILE__)
  end# unless
end# module RBC
