# RBC Library

-------------------------------------

![www.rbc321.cn](rbc.jpg)

 | 官网(www.rbc321.cn)  | RBC插件的发布和提供。  
 | RBC支持群(208182405) | 支持和维护RBC插件。  
 | SU开发群(208254101)  | 研究SU二次开发。  

-------------------------------------

**大家好，不好意思。出于其他原因，以后RBC扩展库暂时不再开源。**

## 简要

* 独立，受社区共同驱动。

* 尽力提供SketchUp建模的最佳方案。
  
* 和谐统一
  使用成熟的技术维护和支持、整体的设计以及细节考虑，操作习惯尽量保持统一。
  
* 成熟实用
  以解决实际问题为理念。
  
* 极致追求性能、架构、兼容性、可靠性、实用性。
  
* 尽力和SketchUp原生态保持一致。

* 支持多版本、多语言。
  支持和提倡自主翻译语言。当然汉化也是一样的。

* 简洁高效
  尽量让用户以最直接简洁的方式解决问题，而不是需要学习大量的插件。
  
* 方便易学
  便于使用或公司培训使用。希望得到敏捷的社区反馈，虚心接受社区反馈更新。

## 解释

* 简洁实用方便，即是不过度设计，以解决问题为第一要务。
  并且尽量隐藏不必要的概念。尽量帮助用户且尽量少地干扰用户。
  缄默原则，如果没什么好说的，就什么也不要说。
  还有一个功能尽量只做好一件事情。
  
* 高效，即是通过对瓶颈进行分析，通过各种手段进行追求性能。

* 兼容性，即是兼容指定的SketchUp版本范围以及同其他插件生态进行兼容。
  不与其他插件生态冲突。
  不能出现由自己造成的任何崩溃。这是绝对的底线。

* 易学易入手，最小知识原则。即是尽量考虑人的学习成本。
  同一个问题，提供一个建议选项。但同时支持多样的方式。
  繁多的插件。易于学习和公司采用以及培训。

* 集中功能模块。把功能相关的部分放到一起。
  但这不是插件集合包。

* 拥抱变化。不管承认不承认，事实是情况一直在变化，虽然有的快，有的慢。
  程序需要设计，但不过度设计。针对接口进行编程。
  合理的依赖关系。降低耦合。拥抱变化、敏捷开发。

* 完备的多国语言支持，用户可以自己翻译成自己国家或地区的语言。
  并支持导入导出。

* 为方便识别，只要是RBC组织的插件，均以RBC开头。

* 尽量使用统一的UI以及同一的模式。

* 插件和建模相紧密结合。实践和理论相结合。

-----------------------------------

## 敏捷开发

* 事情做漂亮，要高质量的程序设计
* 递进和有目的 的做事情
* 采用迭代、循序渐进的方法。没必要一开始就建立一个囊括一切的模型，可以慢慢改进。
* 模块化和简单化
* 大项目拆分为相互联系的多个子项目。并分别完成，在此过程中，一直都处于可用状态。
* 不需要的东西可以不必在模型中增加它
* 当需求有变化时，再来重构这个系统
* 拥抱变化，强调适应性而非预见性。
* 需求在变化，人们的理解也在变化。
* 沟通和谦逊
* 以用户需求为核心，尽可能了解客户的需求。
* 明确目标，资源利用最大化，不做无用的事情


* 最重要的是通过尽早和不断交付有价值的软件满足客户需要。
* 我们欢迎需求的变化，即使在开发后期。敏捷过程能够驾驭变化，保持客户的竞争优势。
* 经常交付可以工作的软件，从几星期到几个月，时间尺度越短越好。
* 业务人员和开发者应该在整个项目过程中始终朝夕在一起工作。
* 围绕斗志高昂的人进行软件开发，给开发者提供适宜的环境，满足他们的需要，并相信他们能够完成任务。
* 在开发小组中最有效率也最有效果的信息传达方式是面对面的交谈。
* 可以工作的软件是进度的主要度量标准。
* 敏捷过程提倡可持续开发。出资人、开发人员和用户应该总是维持不变的节奏。
* 对卓越技术与良好设计的不断追求将有助于提高敏捷性。
* 简单——尽可能减少工作量的艺术至关重要。
* 最好的架构、需求和设计都源自自我组织的团队。
* 每隔一定时间，团队都要总结如何更有效率，然后相应地调整自己的行为。

-----------------------------------

# 适用范围

## 最低配置
* Sketchup 2014及其以上版本
* windows 7
* IE 9 以上
* osx safari ?

## 推荐使用
* windows 7-10
* Sketchup 2015-2016
* IE 10 以上

-----------------------------------

# 架构特点

* 现代软件通常都是许多API建立起来的。
  而这些API又依赖于其他API。API设计的难度和重要性要高一些。
  API应该是一个契约。保证已有的行为前后保持一致。
  向后兼容要好。要具有变更的流程。API通常隐藏内部实现细节。
  但是我们还是要根据实际情况来考虑，而不是教科书式的照搬。
  RBC Library 的作用有些复杂。虽然主张尽量简洁和谐统一，也做到了这一点。但是并不十分单纯。
* 划分模块和包。
  采用包的方式，按责任划分。尽力不相互杂糅，降低耦合性和方便维护。这一点摒弃其他扩展库的做法。
  也不要不管什么都强加给扩展库。扩展库有其责任和任务，不是杂物箱。
* 打造基于相关RBC长期实验实践理论的扩展库。为开发RBC系列插件提供方便。
* 充分吸收其他扩展库的优秀实践，同时规避其短。
  吸取TT LIB、Fredo6 LIB的优点。
  采用TT合理的组织结构和优秀的算法、思想。
  吸取Fredo6很多优秀的实践经验。还有比如用户可自行翻译、个性化特定设置。
  吸取AMS LIB的优点，扩展系统特性。
  还有很多不合理的实现但是想法很好进行优化改良。
  同时协调统一，降低整体复杂性。
* 结合部分调试和反馈进去。建立一整条RBC的开发生态环境。
  其中调试部分对用户关闭，对开发者打开。
* 要极高的加载速度。引入惰性加载的机制。
* 实际项目遇到的情况会很多。
  要可以以最快的速度实施开发，并具有最小的代码量、很好的兼容性、很强的灵活性来适应跟随工程项目进行即时解决问题。
  然后可以很方便地继续迭代。
* 致力于建立方便学习、结构强大的开发库。
* 采用升级的方式迭代扩展库。
* 其他保密。逐渐开放。

-----------------------------------

# 注意

* 尽量使用最新的正式版。
* 开发版一般用于测试。可能会出现问题。
* RBC扩展库为所有的RBC 插件提供扩展支持。所有的RBC插件都需要安装RBC扩展库！
* 2.0版本为了长远考虑，为用户体验感和开发维护的考虑，采用了全新的构架，摒弃了原来架构的一些弱点。
  同时也因此失去了与之前版本的兼容性。RBC系列插件会全面更新。
  只是架构上的改变，对功能不会改变，切换版本时请全面更新新版本。
* 开发版一般会增加实验特性。并不能保证一定稳定。

-----------------------------------


