# UI::WebDialog

## 不足

* 只能传递给Ruby字符串，并且IE下，有长度限制。
* 没有实现异步回调。
* 调试不方便。
* 不支持多国语言。
* 其他BUG

## BUG

* 多次同时请求动作
  下面这段脚本在WIN Sketchup下没有问题，会输出1 2 3 4 5， 
  但是在MAC Sketchup下只会输出5。

<pre><code>
    dlg = RBC::GUI::WebDialog.new()
    dlg.add_action_callback('test'){|dlg, hash|
      p hash
    }
    dlg.set_html(%q{
        <script type="text/javascript">
            window.location = 'skp:test@1';
            window.location = 'skp:test@2';
            window.location = 'skp:test@3';
            window.location = 'skp:test@4';
            window.location = 'skp:test@5';
        </script>
    })
    dlg.show
</code></pre>

* show_modal 在win 下面会有问题。


# GUI::WebDialog

## 定位
* 完美向后兼容
  不与底层API相冲突。底层所有API都要还能使用。而且保持一致。
  底层API和高层次的API可以和谐相处。
  为不破坏生态环境，不许采用猴子补丁。
* 取其优点，避免其缺点。
  不是从零开始，而是以现有开源成果为基础。
  以WebDialogX开源项目为基础，结合TT SKUI开源项目中优秀的部分进行研发。
* 通过异步回调请求数据。可以跨平台多次同时异步回调。
  前后端基本上只有数据交换。并且尽量是json。
* Ruby数据类型在Ruby和JS之间自动的转换。
* 比较完善的支持多国语言。
* 可以一定程度上脱离SU 进行前端自己的第一步调试。
  前后端分离，前端专注于web页面。用数据交换来交互。
* 要求有比较好的可靠性。

## Example:
<pre><code>
    # new a instance.
    dlg = RBC::GUI::WebDialog.new()
    # add action.
    dlg.add_action_callback('test'){|dlg, hash|
      p hash
    }
    dlg.extend_base_js
    # 
    dlg.set_html(%Q{
    <!DOCTYPE html>
    <html>
        <head>
            <meta charset="utf-8" />
            <title>RBC TEST</title>
        </head>
        <body>
            <p>Hello RBC::GUI::WebDialog!</p>
            <!--请把JS脚本放在body后面。-->
            <script type="text/javascript">
                RBC.GUI.WebDialog.callback({
                  name: 'test',
                  data: {"arg1":'1'},
                  success: function(data){ alert(data) }
                })
            </script>
        </body>
    </html>
    })
    # show
    dlg.show
</code></pre>

## Ruby数据类型在Ruby和JS之间自动的转换
Ruby - JS
* Symbol - String
* String - String
* Integer - Integer
* Array - Array
* ...
 




