
# QuadFace Definition

http://sketchucation.com/forums/viewtopic.php?p=348501

## Quads and Topology
A big deal of organic modelling workflow spin around good topology of quads (faces with four vertices/edges). Quads allows for many very useful mesh operations, such as selection rings and loops. Quads are predictable which is why they are so useful.
Many applications let you work with non-planar quads. In SketchUp however, it is not so easy. When you modify a vertex of a quad in SketchUp it auto-folds and breaks the quad into two triangles - where as other 3d applications might leave it as one unit.
At the core of every 3d applications, everything consists of triangles - the only difference is how they expose the triangles to the user. However, there is no reason why SketchUp users can't work with non-planar quads - it's just that the tools need to be aware of them.

## Quads in SketchUp
This toolset is an attempt to begin on such a suite of tools to let SketchUp users work with quads. My approach is conceptually simple: When two faces are separated with a soft edge (smooth only affects shading) then the two faces are treated as one Unit. Click one and you select both and the Entity Info window says you have selected a Surface. Based on that, here is how I define quads in SketchUp:

* The definition of a QuadFace was changed again in version 0.6 because the previous versions relied on the Hidden property. The Hidden property is affected by a model's Scenes, so when you copied quad mesh into a new model you would loose the Hidden property of the diagonals. 

* To update a mesh from the older versions, use:
Tools > QuadFace Tools > Convert > Sandbox Quads to QuadFace Quads

* Native quad face, face with four vertices.
* Two triangles, joined by an edge with the following properties:
  Soft = true
  Smooth = true
  Cast Shadows = false
* Border edges can have any property, just not all of them.
* Faces that makes up a QuadFace cannot have holes in them.