
# RBC::ViewHandler::Shader

* 对 Sketchup::View 进行包装。
* 优化对Retina Display（视网膜显示屏）的兼容处理。
* 把绘制命令化
* RBC 3.0时代开始启用。

# RBC::ViewHandler::TempShader

* 用于临时绘制

## 调用方式：
* 使用代码块的形式调用-灵活性好，最建议的调用方式
<pre><code>
instance = RBC::ViewHandler::TempShader.new(5){|shader|
    shader.drawing_color= "red"
    shader.line_width= 1
    shader.fill= 'DarkGray'
    shader.stroke='blue'
    shader.draw2d_label([120,120,0],'www.rbc321.cn')
}
instance.cursor=(RBC::Cursors[:dropper_invalid])
instance.show
</code></pre>

* 直接对TempShader对象添加命令
<pre><code>
instance = RBC::ViewHandler::TempShader.new(true)
instance.drawing_color= "red"
instance.draw2d_label [20,20,0], 'www.rbc321.cn'
instance.show

instance = RBC::ViewHandler::TempShader.new(true)
instance.show
# 如果是show之后再添加绘制命令，需要使用invalidate方法进行刷新。
instance.drawing_color= "red"
instance.draw2d_label [20,20,0], 'www.rbc321.cn'
instance.invalidate
</code></pre>

* 清空TempShader对象的命令
<pre><code>
instance.clear
</code></pre>

* 命令开始绘制和停止绘制
RBC::ViewHandler::TempDraw#show
RBC::ViewHandler::TempDraw#stop

## 显示时长的控制：
* 不传入或者 传入false(nil), (默认).鼠标一动，即结束显示.
<pre><code>
instance= RBC::ViewHandler::TempShader.new{|shader|
  shader.drawing_color= "red"
  shader.line_width= 1
  shader.draw_vector(Geom::Vector3d.new(616,16,61))
  shader.draw2d_circle([55,55,0], 20)
}
instance.show
</code></pre>

* 传入数字n 那么在n秒以后开始停止绘制.
<pre><code>
instance= RBC::ViewHandler::TempShader.new(5){|shader|
  shader.drawing_color= "red"
  shader.line_width= 1
  shader.draw_vector(Geom::Vector3d.new(616,16,61))
  shader.draw2d_circle([55,55,0], 20)
  shader.draw_element(Sketchup.active_model.selection[0].transformation)
}
instance.show
</code></pre>

* 传入true 一直绘制中，除非切换工具
<pre><code>
instance= RBC::ViewHandler::TempShader.new(true){|shader|
  shader.draw_text([20,50,0],'rbc321.cn')
  shader.draw_text([20,20,0],'rbc321.cn', {:size => 25})

  shader.draw2d_label([100,100,0], '未连接到互联网rbc321.cn')
  p shader.text_real_length('未连接到互联网rbc321.cn')
}
instance.cursor=(RBC::Cursors[:dropper_invalid])
instance.show
</code></pre>
